module Model.Piece where

import String (startsWith)

import Model.Player (..)

type Piece = WhitePawn   | BlackPawn   |
             WhiteKnight | BlackKnight |
             WhiteBishop | BlackBishop |
             WhiteRook   | BlackRook   |
             WhiteQueen  | BlackQueen  |
             WhiteKing   | BlackKing

belongsTo : Piece -> Player -> Bool
piece `belongsTo` player = owner piece == player

owner : Piece -> Player
owner piece =
    if startsWith "White" (toString piece)
        then White
        else Black

-- Show ------------------------------------------------------------------------
show : Piece -> String
show p = case p of
    WhitePawn   -> ""
    BlackPawn   -> ""
    WhiteKnight -> "N"
    BlackKnight -> "N"
    WhiteBishop -> "B"
    BlackBishop -> "B"
    WhiteRook   -> "R"
    BlackRook   -> "R"
    WhiteQueen  -> "Q"
    BlackQueen  -> "Q"
    WhiteKing   -> "K"
    BlackKing   -> "K"
